/*
Program: file-records-adds-drops-v2.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: }file-records-adds-drops-v1.cAϱoƧǤ覡iHзǨƮwqsort()@
Notes: 1) {{VCAF٫oѼƶǨӶǥhlͪӸ`xZAŧiheadBtailPtotal(`I
		  Ӽ)ܼơAHDn
	   2) headPtailܼơA{N]showAll()BsortName()BsortEng()BsortMath()
	      禡ǤJhead޼ơAHQPǵoQѼƶǻ򥻧Φ
	   3) YheadPtailŧimain()ϰܼơAPǤ]Dp{T 
	   4) sscanf()ΪkA˳ۦѮvz@g޳Nu http://ccckmit.wikidot.com/cp:sscanf
*/

#include <stdio.h>	
#include <stdlib.h> /* for malloc(), calloc(), qsort() */ 
#include <string.h>	/* for strcmp() */
#include <conio.h> 	/* for getche() */

typedef struct student student;
struct student {
	char    name[24]; 
	int     eng, math;
	student *prev;
	student *next;
} *head, *tail, dummy; 

int total = 0;

void traceBack(student *tail) /* qYܧܨC@Ӹ`Ie */
{
	student *ptr; /* VC@`IҥΪ */
	
	printf("\n^ܾǥͬpUG\n");
	for (ptr = tail; ptr != NULL; ptr = ptr->prev) 
		printf("%s\t%d\t%d\n",ptr->name,ptr->eng,ptr->math);
}

void showAll(student *head, student *tail) /* ܦCC@Ӹ`Ie */
{
	student *ptr; /* VC@`IҥΪ */
	
	printf("ǥ\t\t^\tƾ\n---------------+-------+-----\n");
	for (ptr = head; ptr != NULL; ptr = ptr->next) 
		printf("%s\t%d\t%d\n",ptr->name,ptr->eng,ptr->math);
		
	traceBack(tail);
}

/* ǤJ޼Ƭ@r(ĴpSteve Jobs 50 60)AqѨmWB^BƾǬ즨Z
   ƧΦs`IAç`I[JC(վtail) */
void addRecord(char line[], int showEntireList) 
{
	char    name[24], str[24]; 
    student *ptr = tail;
    
	//tail = tail->next = (student *)malloc(sizeof(student));	//Ыطs`IһݪŶAætailҫǥ᪺ͬ 
	tail = tail->next = (student *)calloc(1,sizeof(student));
	tail->prev = ptr;
	
	while (1) {
		if (sscanf(line,"%[A-Za-z.] %[^\n]",str,line) == 0) {	/* ŪjpgrΥyIզ^WrAŪJstrAĤ@Ӫťդ᪺Ҧr]line */ 
			sscanf(line,"%d %d",&tail->eng,&tail->math);
			break;
		}
		sprintf(tail->name,tail->name[0]=='\0'? "%s%s": "%s %s",tail->name,str);	/* Ū쪺^W[JtailЩҫ`Iname줧 */ 
	}
	tail->next = NULL;	
    total++;	/* `IӼƼW1 */
    if (showEntireList) { //qYܦCҦ
    	printf("\nW[@ơG%s\t%d\t%d\n\n",tail->name,tail->eng,tail->math);
		showAll(head,tail);
	}
}

/* ǤJ޼Ƭ@r(ĴpSteve Jobs 50 60)ANqmW(^BƾǬ즨Z)ǥH
   CO_Wr۲Ū(ؼ)`IAYANӸ`Ie`Is_ */
void deleteRecord(char line[])
{
	char    fullName[24] = {0}, str[24];
    student *ptr;
    int score;
	
	while (1) {
		if (sscanf(line,"%[a-zA-Z.] %[^\n]",str,line) == 0) break;
		sprintf(fullName,fullName[0]=='\0'? "%s%s" : "%s %s",fullName,str); //sprintf(fullName,fullName[0]=='\0'? "%s%s " : "%s %s ",fullName,str);
	}
		
    for (ptr = head; ptr != NULL; ptr = ptr->next) 
    	if (!strcmp(ptr->name,fullName)) break;  /* AߧYj */ 
	
	if (ptr != NULL) { 			/* ptršANo{ؼ */ 
		if (ptr->prev==NULL) {	/* YNQR`IOCYAhվheadؼФU@`I */
			head = ptr->next;
			head->prev = NULL;
		}
		else {
			ptr->prev->next = ptr->next;	/* e@`IPؼФU@`Is_(¶Lؼи`I) */ 
			if (ptr != tail) 
				ptr->next->prev = ptr->prev;	/* U@`IprevVe@`I */
			else
				tail = ptr->prev;
		}	
		printf("\n@ơG%s\t%d\t%d\n\n",ptr->name,ptr->eng,ptr->math);
    	free(ptr);	/* Rؼи`IҦŶ */
    	total--;	/* `IӼƤ1 */
		showAll(head,tail);
	}
	else
		printf("(%s)bƪsb\n",fullName);
}

int nameAscend(const void *a, const void *b) /* WҦ */ 
{
	student **x = (student **)a;
	student **y = (student **)b;
	
	char lastName[16], nextLastName[16];
	
	sscanf((**x).name,"%s %s %s",lastName,lastName,lastName);
    sscanf((**y).name,"%s %s %s",nextLastName,nextLastName,nextLastName);
	
	return strcmp(lastName,nextLastName); //return strcmp((**x).name,(**y).name);
}

int engDescend(const void *a, const void *b) /* Ҧ */ 
{
	student **x = (student **)a;
	student **y = (student **)b;
	
	return (**y).eng - (**x).eng;
}

int mathDescend(const void *a, const void *b) /* Ҧ */ 
{
	student **x = (student **)a;
	student **y = (student **)b;
	
	return (**y).math - (**x).math;
}

int sortName(student *head, student *indexName[]) /* ЬŪĤG椸uƲߡGCy}Cvq62-67e */
{ 
	int 	i, j;
	char    lastName[20], nextLastName[20], firstName[20];
	student *ptr, *temp;
	
	for (i = 0, ptr = head; ptr != NULL; i++, ptr = ptr->next) 
		indexName[i] = ptr; /* indexName[i]OsCi`I}ANǦiƧ */
	
	qsort(indexName,total,sizeof(indexName[0]),nameAscend);
	
	return 1;
}

/* ǤJ޼ƬC}Y}Pް}CindexEng[]_l}ANH^妨ZC@ƧǨ̾ڡF 
   禡B@zPWsortName()ۦP */
int sortEng(student *head, student *indexEng[]) 
{ 
	int 	i, j;
	student *ptr, *temp;
	
	for (i = 0, ptr = head; ptr != NULL; ptr = ptr->next) 
		indexEng[i++] = ptr; /* indexEng[i]OsCi`I}ANǦiƧ */
	
	qsort(indexEng,total,sizeof(indexEng[0]),engDescend);
	
	return 1;
}

/* ǤJ޼ƬC}Y}Pް}CindexMath[]_l}A禡NHƾǦZC@ƧǨ̾ڡF
   禡B@zPWsortEng()ۦP */
int sortMath(student *head, student *indexMath[]) 
{ 
	int 	i, j;
	student *ptr, *temp;
	
	for (i = 0, ptr = head; ptr != NULL; i++, ptr = ptr->next) 
		indexMath[i] = ptr; /* indexMath[i]OsCi`I}ANǦiƧ */
	
	qsort(indexMath,total,sizeof(indexMath[0]),mathDescend);
	
	return 1;
}

void queryUser(student *head, student *indexName[], student *indexEng[], student *indexMath[])
{
	int i, n;
	int engSorted = 0, mathSorted = 0; /* O^ƧǻPƾǬƧǬO_wL */
	
	while (1) {
		printf("\n**************************************************************************************\n" \
			   "* 1 HmƧ  2 H^Ƨ  3 ^nW  4 HƾǱƧ  5 ƾǲnW  0  *\n" \
			   "**************************************************************************************\n" \
			   "ܱN@\\H(0--5) ==> "); 
		switch (getche()) { 
			case '1':
				printf("\n\nHmƧǵGpUG\n");
    			sortName(head,indexName);
    			for (i = 0; i < total; i++) 
					printf("%s\t%d\t%d\n",indexName[i]->name,indexName[i]->eng,indexName[i]->math);
				break;
			case '2':
				printf("\n\nH^妨ZƧǵGpUG\n");
				engSorted = sortEng(head,indexEng);
				for (i = 0; i < total; i++) 
					printf("%s\t%d\t%d\n",indexEng[i]->name,indexEng[i]->eng,indexEng[i]->math);
    			break;
    		case '3':
    			if (!engSorted) 
    				printf("\n|H^즨ZC@ƧǡAХ\'2\'\\\n");
				else {
    				printf("\nd߭^nWơAJn (1-%d) ==> ",total);
    				scanf("%d",&n);
    				printf("^%d̡G%s\t%d\t%d\n",n,indexEng[n-1]->name,indexEng[n-1]->eng,indexEng[n-1]->math);
				}					
				break; 
    		case '4':
    			printf("\n\nHƾǦZƧǵGpUG\n");
				mathSorted = sortMath(head,indexMath);
				for (i = 0; i < total; i++) 
					printf("%s\t%d\t%d\n",indexMath[i]->name,indexMath[i]->eng,indexMath[i]->math);
				break;					
			case '5':
    			if (!mathSorted) 
    				printf("\n|HƾǬ즨ZC@ƧǡAХ\'4\'\\\n");
				else {
    				printf("\nd߼ƾǲnWơAJn (1-%d) ==> ",total);
    				scanf("%d",&n);
    				printf("ƾǲ%d̡G%s\t%d\t%d\n",n,indexMath[n-1]->name,indexMath[n-1]->eng,indexMath[n-1]->math);
				}					
				break; 
			case '0':
				return;
			default:
				printf("Īܬ0--5AЭsJ\n");
				system("pause");
		}
	}
}

int main()
{
	int     i;
	char    line[120], mode; /* modeΩϤWƪu@Ҧ */ 
	   	
   	tail = &dummy;	/* dummyȮɥγ~`IAɤJ`INϱotailheadlB@קKXAPǥizѳo˼gPAktO? */
    
    FILE *inputFile;/* Jɮצb{N */
	if ((inputFile=fopen("YunTechStudents.txt","r")) == NULL) {   /* ]w}ɼҦJγ~A˵ɮץi_}ҡAYinputšANɮפsb */
		printf("Jɤsb\n");
		exit(1);	/* hX{ */
	}
	
	for (i = 0; i < 4; i++) fgets(line,120,inputFile);	/* Jɶ}Y|CrƱ */
	while (fgets(line,120,inputFile) != NULL) { 		/* ĲɮץݡAN|ƥiŪAưj餺ʧ@ */
  		//Ū@CeAsJlinerܼƤ 
  		if (!strcmp(line,"**************************************\n")) break; /* wŪjuANt@BzҦ */
  		addRecord(line,0);	//Ū쪺Ce(ĴpSteve Jobs 50 60)addRecord()ѨJCFfalseNݱqYܦCҦ 
  	}
  	
  	printf("Ĥ@qŪA@%dO\n\n",total);
  	head = dummy.next; /* wheadVdummy.nextҫ`I */
  	head->prev = NULL;
	showAll(head,tail);
	
	printf("\nHWJɮ\"ju\"HWơAN}lW ...\n"); //system("pause");
	getche();
   	
   	while (fgets(line,120,inputFile) != NULL) { 
		sscanf(line,"%c %[^\n]s",&mode,line);	 /* Ū'+''-']JmodeܼƤAɩwPBzҦ */
  		if (mode == '+') 		/* W[ */
		  	addRecord(line,1);	/* ClineܼƥaddRecord()ѨһݸơAñqYܦCҦ */
		else if (mode == '-') 	/* R */
			deleteRecord(line);	/* lineҧtmWNdeleteRecord()AYsbCANӵñqYܦCҦ */
		else 
			printf("OAsorry :(\n");
  	}
  	fclose(inputFile);
  	
  	student *indexName[100], *indexEng[100], *indexMath[100]; /* 쪺ް}CAw]iO100Ӹ`I} */
  	/* YQϥΦpWTwת}CAitotalƭȤtӼƪ}CAЯdNUgk */
  	/*
	student **indexName = (student **)malloc(total*sizeof(student *)), 
	  	    **indexEng = (student **)malloc(total*sizeof(student *)), 
			**indexMath = (student **)malloc(total*sizeof(student *)); 
	*/

    queryUser(head,indexName,indexEng,indexMath);	/* ͥ\Aè̿ﶵ\ */ 
	printf("{ABye\n");
	
	return 0;
}
